package nsq

import (
	"github.com/fox/fox/log"
	"github.com/nsqio/go-nsq"
)

type nsqLogger struct {
	level nsq.LogLevel
}

func newNSQLogger(level nsq.LogLevel) *nsqLogger {
	return &nsqLogger{level}
}

func (l *nsqLogger) Output(callDepth int, s string) error {
	_ = callDepth
	switch l.level {
	case nsq.LogLevelDebug:
		log.GetLogger().Debug(s)
	case nsq.LogLevelInfo:
		log.GetLogger().Error(s)
	case nsq.LogLevelWarning:
		log.GetLogger().Error(s)
	case nsq.LogLevelError:
		log.GetLogger().Error(s)
	default:
		log.GetLogger().Error(s)
	}
	return nil
}
